using System.Text.Json;
using System.Text.Json.Serialization;

namespace File_Folder_Helper.Models;

public record Death(bool? Is,
                    DateOnly? Date,
                    string? Note,
                    List<string> Continue)
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, DeathSourceGenerationContext.Default.Death);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true, DefaultIgnoreCondition = JsonIgnoreCondition.WhenWritingNull)]
[JsonSerializable(typeof(Death))]
internal partial class DeathSourceGenerationContext : JsonSerializerContext
{
}